//+------------------------------------------------------------------+
//|   2011                                            Fibo_HL_v3.mq4 |
//|  Author's idea by Sauron    Coding by Grein                      |
//+------------------------------------------------------------------+
#property indicator_chart_window

   extern int HL_Period = 28;
   extern string  Line_Fibo = "Fibo";
   extern color Color = Black;

   datetime coordn1_time;   
   datetime coordn2_time;   
   double   coordn1_price;  
   double   coordn2_price;  

   double Level_High, Level_Low;

int init()
  {
   coordn1_time = iTime(NULL,0,0); 
   coordn2_time = iTime(NULL,0,HL_Period); 
   coordn1_price = High[iHighest(NULL,0,MODE_HIGH,HL_Period,0)];
   coordn2_price = Low[iLowest(NULL,0,MODE_LOW,HL_Period,0)];

   ObjectCreate(Line_Fibo, OBJ_FIBO, 0, coordn1_time, coordn1_price, coordn2_time, coordn2_price);
   ObjectSet(Line_Fibo,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet(Line_Fibo,OBJPROP_WIDTH,1);
   ObjectSet(Line_Fibo,OBJPROP_COLOR,FireBrick);

   ObjectSet   (Line_Fibo, OBJPROP_FIBOLEVELS, 7);
   ObjectSet   (Line_Fibo, OBJPROP_LEVELCOLOR, Color);
   ObjectSet   (Line_Fibo, OBJPROP_LEVELSTYLE, DRAW_LINE);
   ObjectSet   (Line_Fibo, OBJPROP_LEVELWIDTH, 1);

   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+0, 0.0);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+1, 0.236);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+2, 0.382);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+3, 0.5);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+4, 0.618);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+5, 0.762);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+6, 1.0);  

   return(0);
  }

int deinit()  { ObjectDelete(Line_Fibo);return(0);}

int start()
  {

   Level_High = High[iHighest(NULL,0,MODE_HIGH,HL_Period,0)];
   Level_Low = Low[iLowest(NULL,0,MODE_LOW,HL_Period,0)];
   coordn1_time = iTime(NULL,0,0); 
   coordn2_time = iTime(NULL,0,HL_Period); 
       
   ObjectSet(Line_Fibo, OBJPROP_TIME1, coordn1_time); 
   ObjectSet(Line_Fibo, OBJPROP_TIME2, coordn2_time);       
   ObjectSet(Line_Fibo, OBJPROP_PRICE1, Level_High); 
   ObjectSet(Line_Fibo, OBJPROP_PRICE2, Level_Low); 
 
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+0, 0.0);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+1, 0.236);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+2, 0.382);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+3, 0.5);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+4, 0.618);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+5, 0.762);
   ObjectSet   (Line_Fibo, OBJPROP_FIRSTLEVEL+6, 1.0);  
  
   double delta_line = (NormalizeDouble(Level_High,Digits) - NormalizeDouble(Level_Low,Digits))/1000;
   
   ObjectSetFiboDescription(Line_Fibo, 0, Line_Fibo + "     " + "0.0" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*0, Digits));
   ObjectSetFiboDescription(Line_Fibo, 1, Line_Fibo + "  " + "0.236" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*236, Digits));       
   ObjectSetFiboDescription(Line_Fibo, 2, Line_Fibo + "  " + "0.382" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*382, Digits));
   ObjectSetFiboDescription(Line_Fibo, 3, Line_Fibo + "     " + "0.5" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*500, Digits));
   ObjectSetFiboDescription(Line_Fibo, 4, Line_Fibo + "  " + "0.618" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*618, Digits));   
   ObjectSetFiboDescription(Line_Fibo, 5, Line_Fibo + "  " + "0.762" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*762, Digits));
   ObjectSetFiboDescription(Line_Fibo, 6, Line_Fibo + "     " + "1.0" + "  " + "=" + "  " + DoubleToStr(Level_Low + delta_line*1000, Digits));   
    
   return(0);
  }


